<?php
	/*_________ File Handler Script for CrossDrop __________*/

	// allow other scripts to communicate with this file
	// TODO - find safe solution to this (current security issue?)

	// TODO - make sure this file was called from a Chrome Extension, not from someone going to
	//		http://130.111.220.27/~kfowlie/cross_drop/

	// _____old attempts at CORS____
	header('Access-Control-Allow-Origin: *');
	header('Access-Control-Allow-Methods: POST, GET, OPTIONS');
	// header('Access-Control-Max-Age: 1000');
	// header('Content-type: application/json');
	// header('Access-Control-Allow-Headers: *');

	 // Allow from any origin
    if (isset($_SERVER['HTTP_ORIGIN'])) {
        header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
        header('Access-Control-Allow-Credentials: true');
        header('Access-Control-Max-Age: 86400');    // cache for 1 day
    }

    // Access-Control headers are received during OPTIONS requests
    else if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
            header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
            header("Access-Control-Allow-Headers:        {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
    }

    // Handle POST requests
    else if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    	header('Access-Control-Allow-Headers: *');
    }

	// get file sent by AJAX
	$name = $_FILES["file"]["name"];
	$ext = pathinfo($name, PATHINFO_EXTENSION);  // TODO - test files w/o an extension
	$type = $_FILES["file"]["type"];
	$size = $_FILES["file"]["size"];
	$tmp_name = $_FILES["file"]["tmp_name"];
	$numFiles = count($tmp_name);

	$retrieval_code = generateId(6);
	// give the retrieval code back to our javaScript AJAX call
	echo $retrieval_code;

	// primary upload directory
	$fileAndPath = "files/" . $retrieval_code . "." . $ext;

	// generate a unique id for file retrieval

	// TODO - make sure id is unique (it's currently unlikely, but still)
	// do {
	// 	$retrieval_code = generateId(6);
	// } while (is_in_table($retrieval_code));
	// 	add_to_table($retrieval_code);


	// connect to the server
	$con = mysqli_connect("localhost", "kfowlie_cd_admin", "crossdrop", "kfowlie_cross_drop");
	// check connection
	if(mysqli_connect_error()){
		error_log("Failed to connect..." . mysqli_connect_error(), 3, "error_log");
	}else{
		// store data (these vars need to match table names)
		$sql_file="INSERT INTO files(retrieval_code, file_path, original_filename) VALUES('$retrieval_code', '$fileAndPath', '$name')";

		// attempt to move file
		if ($con->query($sql_file) == TRUE) {
	    	// move uploaded file
	    	if(move_uploaded_file($tmp_name, $fileAndPath)) {
	    		// successful move!
	    		error_log("Uploaded " . $name . " successfully!\n");

	    		// TODO - add user feedback here?
	    		// TODO - make sure file isn't already here?
	    	}else{
	    		error_log("Could not move the uploaded file.\n", 3, "error_log");
	    	}
		} else {
			error_log("SQL Connection Error: " . $sqlVid . "<br>" . $con->error . "\n", 3, "error_log.log");
		}
	}

	error_log("...\n\n", 3, "error_log");
	error_log("End of Log\n\n", 3, "error_log");
	error_log("...\n\n", 3, "error_log");


	/*
	 * Generate a random sequence of letters and numbers.
	 * http://stackoverflow.com/questions/307486/short-unique-id-in-php
	 */
	function generateId($length) {
		$random = '';
		for ($i = 0; $i < $length; $i++) {
			$random .= rand(0, 1) ? rand(0, 9) : chr(rand(ord('a'), ord('z')));
		}
		return $random;
	}
?>